Minimize the Maximum Difference of Pairs - Leetcode 2616 - Python

  Рет қаралды 16,316

NeetCodeIO

NeetCodeIO

Күн бұрын

Пікірлер: 72
@NeetCodeIO
@NeetCodeIO Жыл бұрын
Tried talking a bit slower in this one, let me know if it's better/worse. Also, I would be uploading daily but most of the daily LC problems lately have been ones I already have videos for :)
@thespicycabbage
@thespicycabbage Жыл бұрын
not all heroes wear capes
@crossvalidation1040
@crossvalidation1040 Жыл бұрын
Great video! Could you please also share the DP solution for this one?
@sumitsharma6738
@sumitsharma6738 Жыл бұрын
You can upload your other videos that you say on podcast that I have a bunch of recorded videos to upload!!
@MP-ny3ep
@MP-ny3ep Жыл бұрын
Yes, please continue with the daily leetcode problems. It's so helpful
@tianmingguo8271
@tianmingguo8271 Жыл бұрын
Thanks for the explanation. The right boundary should be nums[-1]-nums[0] after sorted nums instead of 10**9. This will reduce the running cycles.
@michael._.
@michael._. Жыл бұрын
*log is square root on steroids* - I can never forget this now
@hengyulee4319
@hengyulee4319 Жыл бұрын
A slight optimization can be binary searching the range from 0 to (max(arr) - min(arr)) as the max diff of any pair is bounded by this upper limit.
@tirthajrikame1052
@tirthajrikame1052 Жыл бұрын
Nice catch!
@DanielRodrigues-bx6lr
@DanielRodrigues-bx6lr Жыл бұрын
And since you've sorted the array, might as well just take the difference of (last element - first element).
@hengyulee4319
@hengyulee4319 Жыл бұрын
@@DanielRodrigues-bx6lrexactly
@tirthajrikame1052
@tirthajrikame1052 Жыл бұрын
@@DanielRodrigues-bx6lr yeah! I did the same thing, and this tweak made my code faster than 90%
@uptwist2260
@uptwist2260 Жыл бұрын
Thanks for the daily Similar problems: (pattern is to binary search and test) 875. Koko Eating Bananas 1011. Capacity To Ship Packages Within D Days 1870. Minimum Speed to Arrive on Time
@michelle_tsai_drums
@michelle_tsai_drums Жыл бұрын
lol "log is square root on steroids" brilliant solution with clear explanation as always, plz keep these daily challenges coming
@animesekai4229
@animesekai4229 Жыл бұрын
It is really good, but we can choose the range as 0 to (arr[length - 1] - arr[0]) coz the maximum result we get is the diff between last and first elements.
@panzach
@panzach Жыл бұрын
(a + b) / 2 = a/2 + b/2 = a - a/2 + b/2 = a + (b-a)/2 Just writing it as: `a/2 + b/2` would be both sufficient and easier (to graps) to prevent overflow.
@FluteVJ
@FluteVJ Жыл бұрын
One more very small performance improvement is that we can avoid calling "abs" every time we find the difference. Instead we can just find the difference like nums[i+1]-nums[i] as the array is sorted now.
@sumitsharma6738
@sumitsharma6738 Жыл бұрын
Whenever we see in Question to Find Min(Max) or Max(Min) we will try to use Binary search and here in this question s = 0 and e = max element in my array;
@GuruPrasadShukla
@GuruPrasadShukla Жыл бұрын
if we do l+r then their sum could overflow(be greater) than the max allowed capacity, so instead we take their difference and add it to the left pointer
@vaishnavisahu3167
@vaishnavisahu3167 Жыл бұрын
Hi there, please provide the dynamic programming solution also. (code reference or similar question solution will also work). Thanks!
@PabloEscobaro-jf8ib
@PabloEscobaro-jf8ib Жыл бұрын
Constraints: 0
@GuruPrasadShukla
@GuruPrasadShukla Жыл бұрын
lots of support from india
@vs3.14
@vs3.14 Жыл бұрын
I have been following your 150 problems as well as leetcode's for the last 1.5 months. I have done around 80 (35 easy, 40 medium, 5 hard). But even still when I encounter a new problem in the medium or hard section from the topics I have covered till now(nothing from tree or dp or backtracking yet), I almost always have to lookup a solution. or I just wouldn't be able to solve it. I dunno if I am improving or not if I have to always look up a solution. I do revise the problems the next day. And try to solve them on my own if I had to take help on the first try. Is there any advice you could give?
@sumitsharma6738
@sumitsharma6738 Жыл бұрын
write down your approach in google sheets or on paper to recall what you are thinking when you are trying to solve that problem earlier;
@dineshrajant4000
@dineshrajant4000 Жыл бұрын
Can you explain that mid pointer why l + (r-l)/2 is preventing overflow
@ChrisCox-wv7oo
@ChrisCox-wv7oo Жыл бұрын
Imagine you have a data type that overflows at 16 (valid range 0 to 15) Find the average of 10 and 8. (10 + 8) / 2 overflows when 10 is added to 8, because 18 is greater than 15. 8 + (10 - 8) / 2 does not overflow, because you never risk adding two very large numbers. However, in Python I don't think integers can overflow. This is certainly a concern in languages like C++.
@deathbombs
@deathbombs 6 ай бұрын
The alternative is using r+l /2. The r+l piece can over flow
@indraxios
@indraxios Жыл бұрын
this should be a hard level question
@oksowhat
@oksowhat Жыл бұрын
there is a test case in it where p=3 and the o/p is 1, how is it possible like the set of minimums at best can be [2,1,0] 2 is the correct answer how did you cleared that, its testcase some 400ish
@gouthamp9066
@gouthamp9066 Жыл бұрын
can we have a feature to take only required courses from the website instead everything
@rudrakhare1158
@rudrakhare1158 4 ай бұрын
# Special case when p is 0 if p == 0: return 0
@utkarshsinh1919
@utkarshsinh1919 Жыл бұрын
It's great to see you back!
@suryakantadey717
@suryakantadey717 Ай бұрын
why not take the max till max value in the array ?
@ronbuchanan5432
@ronbuchanan5432 Жыл бұрын
Why is it suddenly OK to naively check only neighbours when the array is sorted? In your example you checked only the tuples (1, 1), (2,3), (7, 10). but you could for example start from (1, 2), (7, 3) ... I don't get it
@mehdisaffar
@mehdisaffar 8 ай бұрын
same question here
@bossmusa9075
@bossmusa9075 Жыл бұрын
how can i be like you man, you are like genius or smth
@akankshasharma7498
@akankshasharma7498 Жыл бұрын
idk why.... I am never able to solve problems like these by myself 😞
@yaswanth8973
@yaswanth8973 Жыл бұрын
It needs lots of understanding and practice
@rustamkarimov1191
@rustamkarimov1191 Жыл бұрын
l, r = 0, max(nums)
@lucifersenpai1948
@lucifersenpai1948 Жыл бұрын
please explain your logic for m = l + (r - 1) // 2 instead of m = (l + r) // 2
@acidtoe1278
@acidtoe1278 Жыл бұрын
It makes no difference in this specific situation, but if the numbers are really big, you can run into overflow problems. for instance if r is close to int_max, and l = 1/2 int_max, l + r will be greater than max_int.
@GuruPrasadShukla
@GuruPrasadShukla Жыл бұрын
log is square root on steroids😂
@m3hdim3hdi
@m3hdim3hdi Жыл бұрын
please someone give us the dynamic programming solution in python please
@vanshrodge7670
@vanshrodge7670 10 ай бұрын
The way he says log is sqare root on steroids🤣
@adilkhatri7475
@adilkhatri7475 Жыл бұрын
just one question. how do you come up with the solutions. i have solved 400 leetcode problems. but still i find difficult to come up with this kind of solution.
@kareni7572
@kareni7572 5 ай бұрын
It’s part of a pattern in binary search. It’s called min of max. Also there’s max of min. So those types of questions are also phrased in that way
@krateskim4169
@krateskim4169 Жыл бұрын
Great video man
@yeah5037
@yeah5037 Жыл бұрын
You talking slower is so much better to absorb!
@jessanraj9086
@jessanraj9086 Жыл бұрын
Great video
@dk4882
@dk4882 Жыл бұрын
Sir please add these questions in NeetCode All Lists also . Then it will be convenient to have all problems in one place during the revision .
@metarus208
@metarus208 Жыл бұрын
yes
@dk4882
@dk4882 Жыл бұрын
@@mfizt2537 obviously I know it . But it will be more convenient if all questions are presented in one list .
@metarus208
@metarus208 Жыл бұрын
@@dk4882 seconded
@pradipakshar
@pradipakshar Жыл бұрын
log is square root on steroids 🤣🤣🤣🤣
@metarus208
@metarus208 Жыл бұрын
kinda a hard problem tbh
@NeetCodeIO
@NeetCodeIO Жыл бұрын
Agreed, especially the optimal solution
@name_surname_1337
@name_surname_1337 Жыл бұрын
10 ** 9 is cringe, you can't do in a real interview. so why do you show this? you should use right = nums[n - 1] - nums[0]
@j_curlin
@j_curlin Жыл бұрын
I have attempted the solution below around 10 times. Time Limit exceeded on every attempt. I have reviewed over and over and can see absolutely no difference from your code. class Solution: def minimizeMax(self, nums: List[int], p: int) -> int: def isValid(threshold): i, count = 0, 0 while i < len(nums) - 1: if abs(nums[i] - nums[i+1])
@j_curlin
@j_curlin Жыл бұрын
reverting your (l+r) // 2 change ran without issue. Confused as to how you got 100% passed on this as I had no luck after many submission attempts.
@doombringer1810
@doombringer1810 Жыл бұрын
I don't get why scanning through the sorted array comparing each neighbours difference with a previously stored "min_value" shouldn't work... It's O(n)
@user-le6ts6ci7h
@user-le6ts6ci7h Жыл бұрын
The minimum distance of a value with a neighbour could fall on either side of it , which we are not sure about,
@doombringer1810
@doombringer1810 Жыл бұрын
​@@user-le6ts6ci7h Yeah, but if we compute the difference between the ith and i+1th elements of the array and take the minimum value between that difference and the "min_malue " you should check on either side of the number. In the case of [1, 2, 4] you check 1-2 when i = 1, and 2-4 when i = 2
@user-le6ts6ci7h
@user-le6ts6ci7h Жыл бұрын
Yeah ,I got you, but , keeping on updating the minimum variable doesn't help us, this is right approach , if you have been asked to find the minimum difference between any single pair , but the question is to minimum diff, and you must choose p pairs , not one, I hope this helps
@doombringer1810
@doombringer1810 Жыл бұрын
​@@user-le6ts6ci7hOh that was the missing piece, thanks!! I guess that to extend my solution to have multiple pairs we could use a min heap to store n lowest values then!
Search in Rotated Sorted Array II - Leetcode 81 - Python
17:36
NeetCodeIO
Рет қаралды 16 М.
Noodles Eating Challenge, So Magical! So Much Fun#Funnyfamily #Partygames #Funny
00:33
I thought one thing and the truth is something else 😂
00:34
عائلة ابو رعد Abo Raad family
Рет қаралды 5 МЛН
小路飞还不知道他把路飞给擦没有了 #路飞#海贼王
00:32
路飞与唐舞桐
Рет қаралды 87 МЛН
Find the Maximum Sum of Node Values - Leetcode 3068 - Python
17:50
Minimum Penalty for a Shop - Leetcode 2483 - Python
14:58
NeetCodeIO
Рет қаралды 9 М.
Maximum Subsequence Score - Leetcode 2542 - Python
13:59
NeetCodeIO
Рет қаралды 23 М.
Dynamic Programming isn't too hard. You just don't know what it is.
22:31
DecodingIntuition
Рет қаралды 197 М.
How I Approach a New Leetcode Problem (live problem solving)
25:31
Premature Optimization
12:39
CodeAesthetic
Рет қаралды 834 М.
Stone Game II - Leetcode 1140 - Python
18:40
NeetCodeIO
Рет қаралды 23 М.
Teaching Neovim From Scratch To A Noob
1:12:55
TheVimeagen
Рет қаралды 230 М.
Noodles Eating Challenge, So Magical! So Much Fun#Funnyfamily #Partygames #Funny
00:33